v.1.3.0.10 от 11.04.2026
1. Исправлены ошибки по работе кнопки перевод РВ в РАО по коду 41. Ранее (после изменений других функций) было следующее ошибочное поведение: 
создавался отчёт, но не открывался, в него не добавлялась строка, а сам отчёт "исчезал" после перезапуска программы.
2. Реализована аналитическая выгрузка, определяющая непарные операции с кодом 41 у выбранной организации. 
Запуск через «ПКМ по организации -> Аналитика -> Непарные операции 41» или через верхнее меню Аналитика -> Выбранная организация –> -> Непарные операции 41». 
Даёт пользователю указать ключевые поля для определения парности (для активностей допуск +-10%). 
Для ключевых полей использующихся при сравнении подсвечивает зелёным цветом те поля, что совпали с максимально похожей записью (по количеству совпавших полей), 
а красным подсвечивает ячейки, у которых значения с ближайшей  строкой не совпали. Должно помочь быстро находить ошибки в случае, если парная строчка есть, но в ней допущены ошибки.
3.Изменён показ сообщений при импорте в программу, с целью уменьшения количества лишних сообщений и ускорения процедуры импорта при пакетной загрузке отчётов.
4. Добавлена функция групповой выгрузки отчётов для разработчиков. Расположена в «Верхнее меню -> Дополнительно –>  Групповая выгрузка отчётов». 
Запрашивает у пользователя номера форм, период, путь сохранения и список организаций (файл .xlsx, первая колонка рег.№, вторая ОКПО). 
Выгружает в выбранную папку все требуемые отчёты в отдельные файлы .RAODB.
5. Добавлена возможность «заморозки» первых 1-3 колонок для форм 1.1-1.9.
6. Изменения в интерфейсе,такие как блокировка команд и кнопок при отсутствии выбранной организации, всплывающие подсказки, 
сброс выбранной организации/отчёта пи щелчке на пустое место таблицы и другое.
7. Часть аналитических выгрузок в .xlsx теперь доступна только разработчикам. Сделано с целью уменьшения путанницы у пользователей, скрытия не нужных им функций.
8. Выгрузки Списка организаций (Аналитика -> Список организаций) теперь имеет возможность введения фильтра по периоду/году.

v.1.3.0.9 от 06.05.2026
1. Реализованы кнопки добавления / удаления радионуклидов в соответствующие ячейки. Для форм 1.7 и 1.8 они не допускают добавление более 1 радионуклида.
2. Обновлены .xlsx шаблоны форм 1.1-1.9, 2.1-2.12 для печати. Реализована защита ячеек от изменения, разблокированными остались только нужные ячейки. Протестировано в Excel и Libre Office.
3. Обновлено руководство пользователя, изображения заменены на актуальные.
4. Небольшие правки проверок 1.5, 1.6.
5. Обновлено поведение выпадающих списков. Теперь по нажатию на кнопку всегда выпадает список со всеми значениями, независимо от того что уже было введено в ячейку. 
Если закрыть список не выбрав значение - в ячейку вернётся предыдущее валидное значение.
6. Небольшие изменения в работу функции очищения ячеек и автозаполнения в формах 1.5-1.7. Теперь при определённых кодах ещё часть ячеек будет автоматически очищаться.
7. Исправление ошибок в работе калькулятора категории.
8. Исправление в работе функций расчёта СНК.
9. Реализована функция выгрузки всех отчётов организации в файлы .xlsx для печати (доступна только разработчикам).
10. Реализован конвертор файлов .xlsx для печати в файлы выгрузки .RAODB (доступен только разработчикам).
11. Обновлена функция выставления ширины по умолчанию у форм 1.1-1.9. Обновлены первоначальные значения для всех колонок этих форм. При первом запуске ПО "МПЗФ", до персональной настройки, таблица должна выглядеть функциональнее и красивее.
12. Обновлена шапка таблицы в формах 1.7, 1.8, для улучшения читабельности и внешнего вида.
13. В проверке форм 1.4 исправлена ошибка с проверкой активности у газообразных источниках.
14. Убрана ошибочно оставленная кнопка включения/выключения автозамены в форме 1.9 - она в ней не используется.
15. Устранена ошибка с отображаемым порядком строчек в части отчётности. Должно снять необходимость в сортировке отчёта по порядковому номеру.
16. Устранена ошибка, заключавшаяся в том, что после введения выпадающих списков, в формах 1.5 и 1.6 при вводе кода операции 41 не появлялось сообщение о недопустимости ввода такого значения 
и значение 41 можно было ввести вручную. Теперь сообщение появляется, корректно работают поведения по возвращению предыдущих валидных значений.

v.1.3.0.8 от 24.04.2026
1. Выпадающие списки в формах 1 для кода операции, кода формы собственности, вида документа, агрегатного состояния, 
кода переработки/сортировки РАО, кода тира объектов учёта. Для кодовых значений присутствуют их описания.
2. Небольшие правки в проверках и автозаполнении, по замечаниям.
3. Исправление ошибки с калькулятором категории.
4. Обновлена работа функции проверки инвентаризаций, убраны лишние сообщения об ошибках.
5. Обновлены шаблоны форм 2.x для печати, исправленны опечатки.
6. Исправление различных замечаний к работе программы.
7. Исправление в проверке формы 2.2, обновлены статусы и проценты выполнения.
8. При сохранении отчёта и закрытия его окна, на главном окне программы выбранная организация более не будет сбрасываться.
9. Для колонок с выпадающими списками реализованы более строгие ограничения по вводу данных.
10. Исправления в проверках форм 1.6-1.8. При определённых ситуациях некоторые символы кода статуса РАО рассчитывались некорректно.
11. Исправления в функции проверки инвентаризаций. При определённой последовательности операций, программа могла выводить ложные сообщения об ошибках в отчётности.

v.1.3.0.7 от 06.04.2026
1. Исправление ошибок с привязкой справочника, приводившей к ошибочным сообщениям об ошибках в отчётности при проверке форм.

v.1.3.0.6 от 10.03.2026
1. Устранение ошибок в работе аналитических функций выгрузки СНК и связанных (проверка инвентаризации, проверка последней инвентаризации, проблемные источники по региону)
2. В фильтр организаций добавлена задержка 300 мс при вводе, для улучшения производительности.
3. При запуске программа сверяет свою текущую версию с последней выложенной на сайте и если там есть обновление, выводит сообщение с предложением обновиться.
4. Обновлён производственный календарь, добавлены рабочие и выходные дни за 2026 год (используется в некоторых проверках).
5. Обновлён справочник радионуклидов.
6. Обновления в формировании и проверках форм 4.
7. Исправлена ошибка с валидацией и выгрузкой в .xlsx отчётов по формам 2, 4, 5, если в них не указан отчётный год.
8. Добавлен режим разработчика.

v.1.3.0.5 от 17.02.2026
1. Возвращена функция выгрузки в .xlsx для анализа.
2. В выгрузки проблемных источников ("Аналитика -> Проблемные источники по региону") вместо 3 листов теперь выгружается 2.
Теперь и источники, что забыли указать в последней инвентаризации и источники, что оказались в последней инвентаризации ошибочно, 
для удобства отображаются на одном листе с указанием статуса.
3. В формах 1.х примечания снова отображаются корректно при открытии отчёта.
4. При выгрузке отчёта в .xlsx для печати снова корректно выгружаются данные исполнителя.

v.1.3.0.4 от 12.02.2026
1. Полностью перерисованно главное окно программы по аналогии с формами 1.0 - 1.9. 
2. Добавлена возможность отображения только выбранного номера форм отчётности.
3. Добавлена возможность устанавливать количество строчек, отображающихся в таблицах организаций и отчётов.
4. При изменении количества отображаемых строчек в таблице, данное значение сохраняется в config файле пользователя, позволяя каждому пользователю настроить приложение под себя.
5. Добавлена выгрузка Аналитика -> Проблемные источники по региону. Данная выгрузка для всех организаций выбранного региона анализирует отчётность и находит источники, которые:
5.1 Забыли указать в последней инвентаризации, поскольку исходя из остальных операций источник должен быть в наличии.
5.2 Ошибочно указали в последней инвентаризации, поскольку исходя из остальных операций источник отсутствует в наличии.
5.3 Ошибочно указали передачу источника, поскольку исходя из остальных операций, источнк на момент операции отсутствовал.
6. Добавлена возможность принудительного испорта тчёта из .RAODB и из .xlsx в выбранную организацию. Сделано в случае, если отчёт по какой-то причине импортируется в отдельную организацию и они "дублируются".
7. Обновлен функционал работы с формами 4 и формами 5.
8. Исправление множества различных ошибок и замечаний.

v.1.3.0.3 от 13.01.2026
1. Исправлены ошибки в проверках форм 1.3 и 1.4, в которых в тексте сообщений были перепутаны коды агрегатных состояний (сама проверка работала корректно).
2. небольшие изменения проверки формы 2.2.

v.1.3.0.2 от 29.12.2025
1. Исправлена проверка формы 1.6, теперь радионуклиды, содержащие пробел (например уран естественный), корректно сравниваются со значениями из справочника.
2. Обновлён справочник радионуклидов, для урана естественного добавлен период полураспада.

v.1.3.0.1 от 16.12.2025
1. Исправление ошибки с изменением данных в формах 1.0 и 2.0.

v.1.3.0.0 от 15.12.2025
1. Добавлены проверки форм 2.3 - 2.11.
2. Исправления в работе функций расчёта СНК, проверок инвентаризаций и проверки последней инвентаризации по пришедшим замечаниям.
3. Исправления в калькуляторе категории. Теперь есть возможность вводить активность как раздельно для нуклидов, так и общую. 
Исправлено определение равновесных радионуклидов, при расчёте учитывается только основной нуклид.
4. Заново отрисован интерфейс форм 1.1 - 1.9. Переписаны все соответствующие функции доступные в этом окне. Реализована возможность выбора отчёта из списка и переключения между отчётами.
5. Реализована возможность сохранения изменений в ширине колонок для каждой из форм отчётности.
6. Реализована возможность изменения количества отображаемых строчек (не более 50).
7, Обновлена работа функции проверки на сохранение изменений. Теперь имеется возможность откатить изменения, принять их или отменить закрытие окна формы. 
Теперь функция должна появлялась только если в форме действительно были изменения.
8. Доработаны и исправлены функции перевода РВ в РАО по коду 41.
9. Реализована возможность расчёта категории в форме 1.1 из контекстного меню.
10. Исправлена ошибка неправильного определения выбранной формы при переходе из Форм 1 в Формы 2 и обратно.
11. Исправлена ошибка с сообщением о жидких РАО.
12. Обновления и исправления в функции Автозаполнения.
13. Добавлена возможность в формах 1.1 - 1.9 скрывать верхний блок данных с данными по отчёту и исполнителю и нижний блок данных с примечаниями.

v.1.2.4.3 от 14.08.2025
1. Исправлена ошибка в расчёте СНК для форм 1.3.
2. Исправлена ошибка с выделением цветом критических ошибок в окне проверки форм.
3. Исправления различных ошибок в проверках форм.
4. Подготовка к внедрению обновлённого перерисованного интерфейса. Обновление работы команд под новую реализацию.
5. Окна форм 1.0 и 2.0 отрисованы заново. Реализована возможность выбора при создании формы, является ли организация юр. лицом или обособленным подразделением. 
В зависимости от этого выбора будут отображаться соответствующие поля для заполнения. Добавлена возможность "реорганизации", т.е. превращения записи обособленного подразделения в юр. лицо и обратно.

v.1.2.4.2 от 28.07.2025
1. Функции "СНК на дату", "Проверка последней инвентаризации", "Автозамена", "проверка форм 2.1, 2.2" временно убраны до окончания их тестирования.
2. Исправления в проверке форм 1.6, 1.8.
3. Исправления различных багов.

v.1.2.4.1 от 26.06.2025
1. Реализована функция автозаполнения в формах 1.1-1.4 (заполняет определённые графы при определённых кодах операции).
2. Исправления в функции расчёта категории, касающиеся случаев с несколькими радионуклидами в составе. Другие исправления в интерфейсе.
3. Исправления в функции пересчёта активности.
4. Небольшие исправления в функциях проверки форм 1.1-1.6.
5. Добавлено поле даты изменения отчёта (в программе не отображается, но хранится в базе данных).
6. Исправление в функции проверки последней инвентаризации.
7. Изменения и улучшения в всплывающих сообщениях.

v.1.2.4.0 от 15.05.2025
1. Исправления в проверках форм 1.1, 1.3.
2. Многочисленные исправления в проверках форм 2.2 по результатам закрытого тестирования.
3. Доработана функция проверки инвентаризаций форм 1.1 по результатам тестирования, подготовка к релизу подобной выгрузки для форм 1.3.
4. Доработана выгрузки СНК по формам 1.1.
5. Реализована выгрузка СНК для форм 1.3.
6. Исправление ошибки с полем ввода даты периода. Ранее, при использовании контекстного меню, в поле была возможность вставить некорректные данные.
7. Реализовано сервисное меню, в котором присутствует возможность открытия полезных файлов и папок при работе с программой. Реализовано окно контактов.
8. В сервисном меню добавлены функции расчёта категории и пересчёта активности.
9. Исправления в выгрузке списка форм 1 и 2.
10. Исправление ошибок, возникающих при работе из под Linux и связанных с открытием файлов/папок, а также с графической частью.

v.1.2.3.20 от 05.03.2025
1. Изменено выделение ячеек в таблицах. Теперь горизонтальная полоса прокрутки не будет устанавливаться в положение по умолчанию (крайнее левое) при отпускании левой кнопки мыши и при выходе мыши за пределы таблицы. Должно стать удобнее выделять ячейки, если полоса прокрутки находилась не в крайнем левом положении. Работает ещё не идеально, но заметно лучше.
2. Исправление ошибки, возникающей при выгрузке в .xlsx разрывов и пересечений. Ошибка возникала в случае, если пользователь работал с базой данных, содержащей одновременно отчёты и по форме 1 и по форме 2.
3. Многочисленные исправления в функциях проверки форм 1.1, 1.2, 1.3, 1.4, 1.6, 1.7, 2.1, 2.2. Для форм 1.1 добавлен справочник наименований упаковок, для которых требуется заполнение формы 1.2.
4. Исправления во всех выгрузках в .xlsx, касающиеся редко возникающей ошибке при работе с некоторыми файлами БД.
5. Обновления в работе функции выгрузки списка наличного количества (СНК).
6. Подготовка к внедрению возможности привязки списков к определённым графам отчётов, с возможностью как ввести уникальное значение, что будет добавлено в список, так и выбрать из имеющихся.
7. Добавлена функция очистки при запуске, которая очищает данные форм 1.0 и 2.0 от лишних пробелов и знаков переноса страницы.
8. Исправление ошибки, возникающей при импорте отчёта в формате .json, при превышении индексом размеров массива.
9. Исправление ошибки импорта из .xlsx отчётов по форме 1.2. Ранее при данном импорте в графу 10 (НСС) помещались значения из графы 1 (порядковый номер).
10. Для удобства, в базовые выгрузки в .xlsx в первых формах добавлена в самый конец графа "Текст статуса РАО", расшифровывающая соответствующее цифровое значение.


v.1.2.3.19 от 29.01.2025
1. Изменения в функции для внутреннего использования, позволяющей при запуске программы по определённому ключу, выполнять последовательно несколько команд на выгрузку данных в Excel, в автоматическом режиме.
2. Переход программы на платформу .NET 9, также обновлены используемые программой библиотеки до актуальных версий.
3. В проверках форм исправлено название радионуклида "америций-243".
4. Исправления в допустимом номере ОКПО при валидации. Теперь на позиции 10-го символа, кроме цифр, там считаются допустимой буква "М".
5. Исправления в функции проверки всех отчётов у организации.
6. Во всех выгрузках в .xlsx теперь сначала идёт сообщение с вопросом о папке назначения, а потом уже создаётся временный файл БД.
7. В некоторых функциях изменён алгоритм сортировки отчётов, что должно положительно сказаться на времени их выполнения.
8. Исправлена ошибка в проверке форм 1.1, в частности теперь для равновесных радионуклидов учитывается только главный нуклид.
9. Добавлена протестированная функция проверки форм 2.1. Вызывается она аналогично проверкам форм 1. В случае, если в текущей БД есть и формы 1 и формы 2, то проверка будет выполнена сразу, если соответствующих форм 1, для выбранной формы 2.1 нет, программа предложит выбрать файл БД, содержащий отчётность по форме 1.
10. Теперь все команды по проверке форм работают асинхронно и не блокируют интерфейс. Реализовано, поскольку в отличии от проверок форм 1, проверка формы 2.1 может занимать определённой время.
11. Исправил возможность занесения в графы начала/конца периода некорректных данных. Ранее там уже была маска, с клавиатуры и через ctrl+v такие данные уже нельзя было занести, но через "ПКМ -> Вставить" в контекстном меню, маска не работала.
12. Исправлена ошибка в проверке форм 1.8 касательно считывания строк при пустом коде РАО.
13. Исправлена ошибка, изредка приводившая к попаданий в выгрузку в Excel разрывов и пересечений лишних записей. Возможность возникновения подобной ошибки исключена для всех других обращений к БД.
14. Исправление в работе функции проверки строчек на дублирование, для форм 1.1-1.6 она теперь учитывает и графу № УКТ.

v.1.2.3.18 от 15.01.2025
1. Исправлено заполнение ячейки 14 (активность трития) в форме отчётности 2.2.

v.1.2.3.17 от 06.11.2024
1. Переработана функция проверки всех имеющихся у организации отчётов. Для её вызова необходимо нажать ПКМ на организации и в контекстном меню выбрать "Проверить все формы". Программа предложит выбрать папку для сохранения отчётов, в ней для каждого отчёта будет сохранён отдельный файл с выявленными к отчёту замечаниями.
2. Исправлена ошибка в функции выгрузки в Excel истории движения источника. Ранее выгрузка могла работать некорректно, если ей не удалось распознать дату операции. в любой из форм для данного источника.
3. Многочисленные изменения, направленные на оптимизацию функций выгрузок в Excel.
4. Для внутреннего использования, добавлены особые ключи запуска, позволяющие запускать более одной копии программы и выбирать при запуске используемую базу данных.
5. Исправления в проверках форм 1.7 и 1.8.
6. Изменения, связанный с готовящимися к выпуску функциями проверки СНК, правильности заполнения инвентаризаций и проверок операций приёма/передачи.
7. Исправлена небольшая ошибка в импорте файлов .json.

v.1.2.3.16 от 12.09.2024
1. Добавлены проверки форм 1.8, пока что в тестовом режиме, возможно наличие ошибок в проверках.
2. В формах 1.5-1.8 добавлена графа "Номер документа". Располагается в самом конце формы.
3. Для всех выгрузок в .xlsx, а также для выгрузки отчёта или всех отчётов организации, реализована асинхронная работа. Теперь, при выполнении этих функций, 
интерфейс не будет блокироваться, программа не будет визуально "зависать". Кроме того добавлен ползунок загрузки, информирующий пользователя о ходе выполнения задачи 
и позволяющий её отменить. В ближайшее время аналогичный функционал будет реализован для функций импорта и вообще для всех продолжительных задач.
4. Исправлена ошибка при запуске программы на Astra Linux с использованием нескольких дисплеев.
5. Доработан логгер ошибок, располагается в папке RAO/logs/Crash.txt. В него добавлена возможность записи из множества мест с возможность возникновения ошибки. 
Кроме того, в него записываю предупреждения, о сбое в работе определённых функций, не прекращающих работу программы.
6. Исправления ошибок в функции проверок форм 1.7.
7. Реализована возможность проверки отчёта без его открытия (правая кнопка мыши по отчёту -> проверить), а также выгрузка в .xlsx результатов проверки всех отчётов у организации 
(выгружается в указанную папку по 1 файлу на 1 отчёт, вызывается по "правая кнопка мыши по организации -> проверить все формы организации").
8. Переработана логика работы части выгрузок в .xlsx с целью ускорения их выполнения (в частности функция выгрузки истории движения источника).
9. Многочисленные незначительные исправления и доработки.

v.1.2.3.15 от 23.08.2024
1. Добавлены проверки форм 1.7, с учётом замечаний в ходе тестирования.
2. Исправления по найденным замечаниям в функциях проверок форм 1.1-1.6.
3. Добавлена возможность сохранения отчёта о проверки формы в файл формата .xlsx (или открытия его временной копии).
4. В формы 1.2, 1.3, 1.4 добавлены кнопке перевода РВ в РАО по коду 41 для всех имеющихся строчек с данным кодом. Ранее данная кнопка была только в форме 1.1.
5. Добавлен логгер, куда идут сообщения о критических ошибках в ходе работы программы. В дальнейшем список ошибок, попадающий в этот логгер, будет расширяться.
6. Исправлена проверка на порядковый номер в формах 1.1-1.7, откорректировано сообщение, добавлены методы исправления ошибки.
7. Исправлена функция копирования в форме 1.7. В данной форме, из-за отличия в шапке таблицы от остальных (4 уровня вместо 3), некорректно определялись ячейки, 
их которых копировались данные. Данная ошибка проявлялась при копировании строки целиком или при копировании блока из не скольких ячеек.
8. Исправлена проверка на дублирование строк. Теперь она отображает данные строчки с разбивкой по группам, а не просто перечисление всех строчек, что имеют дубликаты. 
Кроме того, данные строчки теперь перечисляются периодами, через дефис, чтобы избежать слишком длинных сообщений при проверке больших форм.
9. Дополнен и откорректирован справочник упаковок, дополнен справочник радионуклидов.
10. Исправлена ошибка, вызывающая вылет программы, в случае, если пользователь в любой форме выделил ячейку, переключил страницу и в ячейке с номером страницы нажал кнопку "Del".
11. Сообщение об успешном импорте из .xlsx более не появляется, если не удалось прочитать ни один из импортируемых файлов.
12. Исправления в валидации и автоматическом преобразовании числа в экспоненциальную форму во всех формах (теперь этим управляет единая функция на все такие графы).

v.1.2.3.14 от 22.07.2024
1. Исправления в работе функции определения размера программы при запуске под linux (из-за ошибки функции вызывала вылет программы при запуске).
2. Исправления замечаний к работе функции частичного заполнения паспорта на упаковку твердых РАО в форме 1.7.

v.1.2.3.13 от 16.07.2024
1. Добавлена функция частичного заполнения паспорта на упаковку твердых РАО в форме 1.7.
2. Добавлен шаблон паспорта в формате .xlsx.

v.1.2.3.12 от 12.07.2024
1. Исправления в функциях проверки форм 1.1-1.6 по замечаниям пользователей.
2. Добавлено несколько сообщений пользователю, при определённой последовательности действий при переводе источника по коду операции 41.
3. Обновлён справочник радионуклидов.
4. Исправления в импорте отчётов из АЧ (формат .json), исправлен ряд ошибок, работа функции повторно протестированная на реальных данных.
5. Добавлена функция быстрой сортировки отчёта в случае, если по какой-либо причине сбился порядковый номер. Вызывается из контекстного меню. 
Исправлена функция выставления порядкового номера для строки (не меняет имеющийся порядок строк, а только изменяет порядковый номер).
6. Добавлена функция автоматического удаления пустых строчек во всех формах при их закрытии.
7. При выделении ячейки и появления в ней курсора, внутри ячейки теперь можно перемещать текст при помощи стрелок влево и вправо.
8. Во всех графах всех форм добавлено автоматическое удаление пробелов и знаков переноса строки в начале и конце значения. 
Внесены многочисленные изменения в валидации различных колонок во всех формах. При проведении проверок 1.1-1.5 при сравнении данных, все возможные пробелы теперь игнорируются.

v.1.2.3.11 от 17.06.2024
1. Исправления в функциях проверки форм 1.1-1.6 по замечаниям пользователей.
2. Функция определения размера программы при запуске, теперь умеет учитывать введённый пользователей масштаб отображения (в windows).
3. По результатам проверки актуальности списка радионуклидов в предыдущей версии, в данной был обновлён справочник радионуклидов.

v.1.2.3.10 от 05.06.2024
1. Исправления в функции перевода форм по коду 41. Исправлены ошибки в работе, изменён алгоритм поиска формы, в которую должен быть переведён выбранный источник.
2. Добавлена функция проверки форм 1.5 и 1.6.
3. В функции проверки форм 1.1-1.4 внесены исправления в соответствии с замечаниями пользователей (например в одной из проверок в форме 1.1 в списке ошибок, 
было неправильно подписано название графы). Добавлена проверка на дублирование строк. Расчёт количества рабочих дней между датами теперь работает корректно.
4. Обновлены данные в используемом программой справочнике радионуклидов.
5. В проверках форм при проверке сроков отчёта и дат операции/документа теперь учитываются все государственные выходные и праздничные дни, в том числе перенесённые, начиная с 2021г.
6. Для внутреннего использования, реализована функция определения максимальной длины строки в каждой графе во всех формах.
7. Исправлена ошибка в работе кнопки "Дополнить" при импорте отчётов.
8. Добавлена кнопка перевода всех имеющихся источников с кодом операции 41 в соответствующие им формы (с последующим открытием последней по периоду).
9. Для внутреннего использования, добавлена функция, формирующая список всех радионуклидов, введённых пользователями в формах 1.1-1.9, 
и сверяющая его с имеющимися в справочнике радионуклидов, для выявления и заполнения отсутствующих.

v.1.2.3.9 от 24.05.2024
1. Исправлена работа кнопки "Дополнить" при импорте отчётов из форматов .raodb/.xlsx/.json.
2. Исправлено определение размера программы при запуске под ОС линукс в зависимости от разрешения монитора.
3. Реализована функция перевода источника по коду операции 41 из форм 1.1-1.4 в 1.5, 1.6 соответственно (с поиском подходящей под период формы или созданием новой формы), 
по нажатию соответствующей кнопки в контекстном меню.
4. Добавлена функция автоматического скрытия/открытия окна при переводе источника в форму 1.5.
5. Исправление ошибок в функция проверки форм 1.1, 1.3 (по замечаниям пользователей).
6. При проверке форм, добавлено отдельное окно в случае, если ошибок не обнаружено.
7. Исправление сортировки отчётов в случае, если у отчёта не введена дата окончания периода.
8. Программа теперь при валидации и проверках на ошибки при заполнении форм использует обновлённый, дополненный справочник радионуклидов.

v.1.2.3.8 от 03.05.2024
1. Исправления и доработки в модуле проверок форм 1.1 - 1.4. Релизная версия.
2. Исправления ошибок, касающихся работы нововведений из последних версий под Astra Linux.
3. Исправление ошибки при пакетном импорте файлов .xlsx.

v.1.2.3.7 
1. Доработка модуля проверки форм 1.1 - 1.4 по результатам внутреннего тестирования.
2. Исправление нескольких небольших ошибок, появившихся в версии 1.2.3.6.
3. Подготовка базы к миграции и к изменению типов данных.
4. Реализация каскадного удаления из базы данных.
5. Исправление возможного "вылета" программы при экспорте формы в .xlsx при определенном порядке действий.

v.1.2.3.6 от 26.03.2024
1. Исправление выгрузки организации в .raodb. Ранее была ошибка, при которой если выгрузить организацию в .raodb и попытаться импортировать её обратно, 
возникала ошибка из-за задублировавшихся id отчетов.
2. Исправлена ошибка, возникающая с импортом отчётов из .xlsx и .raodb при определенном порядке действий.
3. Исправлена ошибка с окном сохранения данных при закрытии формы.
4. Исправление подстройки размера окна программы под текущее разрешение монитора. Реализация данной функции под Astra Linux.
5. Реализована функция сравнения данных форм 1.0 и 2.0 при импорте отчетов из .raodb/.xlsx/.json. При наличии различий, открывается отдельное окно, 
позволяющее посмотреть изменения, внести в них корректировки.
6. Реализация модуля проверок форм 1.1 - 1.4. Проверки на данный момент выполняются в пределах открытой формы.

v.1.2.3.5 от 13.03.2024
1. При импорте отчета/отчетов/организации из .raodb/.xlsx/.json добавлено окно проверки изменений в титульной форме организации 1.0/2.0, 
с возможностью отказаться от изменений, выбрать конкретные изменяемые поля, а также вручную изменить данные.
2. Исправлены ошибке в работе кнопки "Проверить" в форме 1.1, уточнены требования к форме на соответствие приказу.
3. Реализована автоподстройка размера основного окна под мониторы с различным разрешением.
4. В выгрузке в .xlsx форм 2.3 (всех, у выбранной организации или при выгрузке всех форм) формат колонки 18 "срок действия" изменён с численного на дату.
5. Теперь во всех формах отчетности при нажатии клавиши Delete или комбинации клавиш Ctrl+v в случае если в ячейке выбран определённый кусок текста, 
содержимое ячейки не будет полностью удаляться, будет удалён только выделенный текст.
6. Исправлена ошибка, при которой после выгрузки организации в .raodb, не открывался головная форма этой организации.
7. Исправлена ошибка, при которой при закрытии головной формы организации не нажимая предварительно кнопку "сохранить", программа могла вылететь.

v.1.2.3.4 от 26.02.2024
1. Исправлены ошибки версии 1.2.3.3 (долго производились выгрузки форм в .xlsx).
2. В выгрузке в .xlsx форм 1.7 (всех, у выбранной организации или при выгрузке всех форм) в колонку 7 "Номер упаковки (идентификационный код) 
ошибочно помещались значения из колонки 6 "Заводской номер".

v.1.2.3.3 от 24.01.2024
1. Исправления в заголовках форм 1.5.
2. Исправлена ошибка с выгрузкой в Excel истории движения источников (появилась из-за изменения типа данных на дату).
3. Исправлена ошибка с выгрузкой в Excel списка исполнителей.
4. В выгрузках в Excel форм x.x и всех форм вернул старый порядок колонок (по просьбе Комарова И.).
5. В выгрузке в Excel разрывов и пересечений теперь учитывается, что по Приказу 1/24 отчеты начинались со следующего дня, а в приказе 1/13 день в день.

v.1.2.3.2 от 25.12.2023
1. Если при запуске программы происходит ошибка чтения/создания файла базы данных, пользователю будет показано соответствующее сообщение.
2. Исправлена ошибка, при которой при создании новой формы и её заполнении, данные могли не сохраниться, если закрыть форму не нажимая кнопку "Сохранить".
3. Исправлена ошибка в сообщениях пользователю с признаком инвентарного отчёта (ИНВ) при импорте отчётов из .RAODB.
4. Исправления загрузки в память строчек форм. Устранена ошибка при которой если удалить из отчета строку, а потом импортировать .RAODB файл с отчетом, 
совпадающий с данным и его дополнить, то добавление строчек произойдет некорректно.
5. Во всех выгрузках в .xls (Excel) теперь дата конвертируется в формат даты (ранее был строковый формат).
6. Обновление до .NET 8.

v.1.2.3.1 от 15.12.2023
1. Значительно ускорено время выполнения импорта данных из файлов .RAODB.
2. Исправлены ошибки, появившиеся в выгрузках Excel в версии 1.2.3.0 (поскольку функции полностью переписывались). 
Теперь сортировка, парсинг формата данных и т.п. работают корректно.
3. Исправлено имя по умолчанию для файла выгрузки организации .RAODB.
4. Изменён размер окна программы по умолчанию.
5. Исправлена ошибка, из-за которой при импорте формы в формате .xlsx значения ОКПО организации сравнивались только у юридических лиц, 
что могло приводить к задвоению строк организации при импорте.
6. Добавлены соответствующие сообщения пользователю, если при создании/чтении файла БД произошла ошибка.
7. Исправлена ошибка с отображениям количества загружаемых при импорте форм в сообщении пользователю.

v.1.2.3.0 от 12.12.2023
1. Изменена работа программы с базой данных, что потребовало внесения значительных изменений в большинство функций программы. 
Теперь строчки форм загружаются в оперативную память только при необходимости, что значительно ускорило быстродействие
для больших баз данных, значительно уменьшило потребление оперативной памяти, ускорило работу программы, значительно ускорило время запуска
и улучшило её стабильность.
2. Импорт данных из .JSON (АЧ) реализован для всех форм 1.х и 2.х. Исправлены ошибки в работе.
3. Добавлена проверка для сообщения о сохранении формы при закрытии, окно более не появляется, если изменений в форме не было (иногда появляется для некоторых форм).
4. Исправлены ошибки в выгрузке в Excel форм с суммарной строкой (2.1 и 2.2). Теперь такие формы экспортируются и импортируются корректно, учтена группировка. 
Ранее суммарные строки в выгрузке считались программой за отдельные строчки отчета.
5. Исправлена ошибка со сбросом номера страницы на 1 при различных операциях.
6. В выгрузку в Excel разрывов и пересечений добавлено поле "совпадение".
7. Выгрузки в Excel теперь работают параллельно основной программе, с ней можно продолжать работу и вносить изменения пока выполняется выгрузка.
8. Исправлена ошибка, которая в отчётах более 10 тысяч строк приводила к ошибке из-за функции рекурсии.
9. Оптимизирована работа выгрузок в Excel с использованием параллельной загрузки ядер ЦП. Следует учесть, что поскольку данные теперь загружаются в память 
только при необходимости, сами выгрузки в Excel выполняются несколько дольше, чем ранее.
10. Теперь если у выбранной организации нет необходимых форм, программа не будет делать выгрузку и сообщит об этом.
11. Исправлена валидация полей в формах 1.6 и 1.9.
12. Исправлена ошибка в функции "очистить ячейки".
13. Номер страницы теперь сбрасывается при смене организации, но не сбрасывается при её открытии.

v.1.2.2.14 от 03.10.2023
1. Первая реализация импорта данных в МПЗФ из формата .Json (формат данных используемый Автономной Частью).
2. Исправлена ошибка, с работой программы в Astra Linux из под доменной учетной записи (например ivanov@rosatom.ru).
3. Уведомления о сохранении теперь появляются по центру экрана.
4. Исправлена ошибка, при которой в выгрузках в Excel в Astra Linux файл предлагалось сохранить без расширения (.xlsx).
5. Исправления в сообщениях при импорте .RAODB файла.
6. Исправлена сортировка данных в выгрузке в Excel всех форм.
7. Исправлена ошибка с выделением ячеек, когда из-за неправильно заданных размеров при щелчке на край ячейки выделялась соседняя.
8. Исправлена ошибка с переключением на нулевую страницу.
9. При  выгрузке в Excel списка организаций, проверка теперь идёт и по рег номеру и по ОКПО (ранее только по рег. номеру).
10. Исправлена валидация значений поля "Электронная почта".
11. При выгрузке в Excel конкретной организации, в названии файла убрано имя базы данных. 
12. В всех формах исправлена возможная ошибка с конвертацией данных в экспоненциальной формат.

v.1.2.2.13 от 27.09.2023
1. Исправлена ошибка в выгрузке "Excel" -> "Все формы", ранее в сокращенное наименование организации всегда помещалось наименование юр. лица, 
независимо от наличия обособленного подразделения.
2. Добавлена выгрузка "Excel" -> "Список исполнителей".
3. В Astra Linux теперь главные окна появляются по центру экрана (для части всплывающих сообщений ещё не реализовано).
4. Импорт данных из АЧ в формате JSON (не сделано).
5. Исправлена ошибка, при которой в Astra Linux при сохранении любой выгрузки файлу не добавлялось расширение .xlsx.
6. Исправлена ошибка, при которой часть выводимых пользователю сообщений не появлялась.

v.1.2.2.12 от 03.07.2023
1. Исправлена ошибка в выгрузке в Excel аналитического отчёта разрывов и пересечений. Ранее в отчёт не попадали пересечения в случае, 
если у отчётов совпадали даты начала или конца периода.
2. Добавлена кнопка "Excel -> Все формы" выгружающая в один файл .xlsx все имеющиеся в базе формы. (на полной базе может занимать несколько минут).
3. Исправлена ошибка в работе программы на Astra Linux, приводившая к тому, что файл базы данных не сохранялся.
4. Исправлена ошибка, при которой не загружались данные из файла базы данных, если файл из папки temp использовался одним из процессов (был открыт).
		
v.1.2.2.11 от 18.05.2023
1. Исправлена ошибка, при которой при выгрузке в эксель всех форм (например всех форм 1.6) и отсутствии выбранной организации, выгрузка не происходила, 
программа вылетала.
2. Исправлена ошибка валидации кода операции в форме 1.6.
3. Исправлена ошибка в форме 1.7 при копировании в форму значений нескольких столбцов или строчки/строчек целиком.
Ранее при таком копировании в столбец №29 "трансурановые радионуклиды" ошибочно заносились данные из столбца №28 "альфа-излучающие радионуклиды 
(исключая трансурановые)".
4. Доработана функция суммирования в формах 2.1 и 2.2, теперь при большом количестве строк она выполняется "разумное" количество времени.
5. С целью уменьшения вероятности вылета программы, большинство функций проходят проверки на ошибки выполнения.
6. Реализован протокол импорта, теперь при импорте каждой формы в файл RAO\logs\Import.log сохраняется информация об операции в виде: 
дата и время__порядковый номер__рег.№__ОКПО__№ формы__кол-во записей__тип операции(пустое при добавлении)__период/год__сокращённое наименование__полный путь 
до имп.файла.
7. Исправлена ошибка, при которой при импорте в excel, расширение .xlsx в имени файла дублировалось.
8. В выгрузках в Excel "Список форм 1" добавлена возможность фильтрации по диапазону дат. Если ничего не вводить или если обе даты диапазона не получится распознать, 
то выгрузка будет идти как прежде. Если не удаётся распознать одну из введённых дат диапазона, она не будет учитываться при поиске.
9. Аналогично предыдущему пункту, в Excel "Список форм 2" добавлена возможность фильтрации по диапазону лет или по конкретному году.
10. Добавлено сообщение о завершении операции импорта из .raodb.

v.1.2.2.10 от 14.04.2023
1. Устранена ошибка, при которой файл экспорта формы, находящийся в папке RAO не читался корректно и организация с формой не отображались, 
приходилось использовать функцию импорта.
2. Устранена ошибка, при которой не читались файлы .raodb в папке RAO (читались только .RAODB). 
При импорте разрешение файла также стало независимым от регистра (видны и raodb и RAODB).
3. Устранена ошибка, из-за которой в Astra Linux не работали все выгрузки в Excel, при попытке выгрузки программа вылетала 
(ошибка появилась в v.1.2.2.5 из-за несовместимости библиотек).
4. Исправлено расположение файлов в Astra Linux, папка RAO создаётся в папке текущего пользователя (/home/username). 
В качестве папки с временными папками теперь всегда используется папка temp, находящаяся рядом с папкой RAO. 
Файлы в папке temp очищаются при каждом запуске программы.
5. Все функции, касающиеся паспортов ЗРИ, теперь ищут паспорта не только в указанной папке, но и во всех вложенных. 
Также изменено расположение паспортов по умолчанию.

v.1.2.2.9 от 04.04.2023
1. Устранена ошибка версии 1.2.2.8, в которой при выгрузке формы выгружались все формы организации.

v.1.2.2.8 от 17.03.2023
1. Устранена ошибка, при которой при импорте из excel файла в текущую базу форм 2.5, 2.6, 2.7, 2.8, 2.9 происходило смещение данных на одну колонку вправо 
(последняя при этом терялась). 
Также при импорте из excel исправлен импорт поля Вид документа в формах 1.5, 1.9.
2. Попытка устранить периодически возникающую у части пользователей ошибку с копированием данных в буфер обмена (требуется тестирование).
3. При импорте в базу из файлов выгрузки в excel исправлены все сообщения по аналогии с импортом из .raodb.
4. При выгрузке Всех форм 1.х или 2.х если рег.номер не был заполнен, то ставилось ОКПО юр лица, даже если оно было у подразделения. 
Теперь туда вносится ОКПО подразделения.
5. В выгрузку "Список форм 1" добавлен столбец инвентаризации. Если в нём указано "ИНВ" - все строки отчета имеют код операции 10, если "инв" - хотя бы одна, 
если пусто - нет ни одной строки с кодом операции 10 (аналогичная система существует в сообщениях об импорте из .raodb и из excel.
6. Добавлена функция выгрузки всех форм для организации и она же, но с указанием диапазона дат выгружаемых форм.
7. Во всех сообщениях при импорте/экспорте для удобства заменен порядок вывода ОКПО и наименования. Для всех выгрузок в .raodb добавлена кнопка открытия папки 
расположения файла.
8. Устранена ошибка, при которой при импорте из нескольких файлов Excel с формами отчётности 1, программа вылетала.
9. В выгрузке в excel "списка организаций", добавлен столбец "Орган управления".
10. В имена файлов выгрузок .raodb добавлена текущая версия программы.
11. Для всех выгрузок в excel добавлена возможность открыть выгрузку во временном файле (сохраняется в RAO\temp, папка очищается при следующем запуске программы).
12. Для всех выгрузок в excel формируются имена по умолчанию (по аналогии с выгрузкой в .raodb).
13. Все операции по экспорту в .raodb не блокируют работу интерфейса программы (работают параллельно).
14. У поля субсидия, значение 100 теперь проходит валидацию во всех формах.
15. В списке организаций добавлены кнопки "Выгрузить организацию" (выгружает все формы данной организации), "Выгрузить организацию с указанием диапазона дат"
(выгружает формы за определенный период) и "Выгрузить все организации" (выгружает в отдельные .raodb файлы каждую организацию из базы).
16. В выгрузке в excel для аналитики формы 2.7 исправлена ошибка с форматом данных полей: выброс радионуклида разрешенный, фактический, 
фактический за предыдущий год.

v.1.2.2.7 от 08.02.2023
1. Исправлена ошибка конвертирования полей содержащих дату при импорте из Excel в МПЗФ во всех формах отчётности. 
Ранее дата при таком импорте отображалось численное количество дней от OLE Automation Date.
2. Исправлена ошибка, при которой программа дольше открывала файл базы при наличии посторонних файлов в папке RAO. 
Кроме того, при нескольких файлах .raodb в папке RAO, программа теперь открывает не первый по алфавиту, а последний изменённый файл. 
Если последний файл .raodb повреждён, программа будет пытаться открыть предыдущий файл по дате изменения.
3. При загрузке программы, в статус баре подробнее описано что загружается в данный момент.
4. Исправлена ошибка дублирования организаций при импорте (нужна проверка).

v.1.2.2.6 от 01.02.2023
1. Исправлена ошибка, из-за которой не сбрасывалась выбранная организация и её формы.
2. Добавлены уведомления, о невозможности создания формы в случае, если не выбрана организация.
3. Исправлена ошибка, при которой при удалении формы, не обнулялась выбранная форма и по двойному щелчку на таблицу форм, 
программа пыталась изменить уже удалённую форму.
4. Исправлена ошибка при импорте отчёта, приводившая к внесению отчёта в не ту организацию, а также ошибка, при которой организации дублировались, 
в том числе "задвоение" организации при импорте отчётов по форме 2.х.
5. Значительно сокращено время создания новой пустой строчки отчёта/примечания во всех формах.
6. У всплывающих окон, требующих ввода чего-либо, настроена фокусировка на строку ввода при отображении, теперь не нужно каждый раз нажимать на строку перед вводом. 
Закрытие окна по кнопке Enter.
7. Для работы с паспортами (копирование имени, выгрузки в excel), дата теперь распознаётся с учетом множества шаблонов 
(две цифры для года; "/", "-" в качестве разделителя), в имени паспорта дата заменяется на год, если дата не распознана, то она заменяется на 0000;
8. При открытии второй копии программы появляется информационное окно, что программа уже открыта, вторая копия программы закрывается после закрытия этого окна;
9. При выгрузке формы в excel или импорте из excel все значения проходят дополнительные проверки при преобразовании во избежание вылетов 
(во многих формах ранее при импорте
 были возможны вылеты программы, например при импорте формы 1 при незаполненном поле НСС), поля которые можно складывать преобразованы в числовые.
10. Во всех выгрузках в excel все строчки заголовков теперь закреплены при пролистывании, доработан подбор ширины колонок, 
исправлены отсутствующие заголовки колонок в форме 2.11,
 доработана/добавлена логика сортировки строчек в выгрузках (по рег. номеру, периоду/году, порядковому номеру);
11. Доработана логика импорта из .raodb, изменены соответствующие сообщения, добавлены кнопки пропуска подобных сообщений, 
устранены ошибки при импорте множества организаций/отчетов, 
добавлена информация, если ли в отчёте коды операции 10 (приписка (ИНВ) если все строчки с данным кодом, (инв) если хотя бы одна, но не все строчки).
12. Были жалобы на участившиеся вылеты программы при долгом использовании, их число должно уменьшиться, требует тестирования.
13. Исправлена ошибка с полем даты после импорта (в некоторых формах к дате добавлялось нулевое время).
14. Другие мелкие исправления.

v.1.2.2.4 от 12.12.2022
1. В уведомлениях убрано упоминание оперативной и годовой отчетности (заменено на отчетность по форме 1,2).
2. В аналитической выгрузке в Excel отчетов, для которых нет соответствующих файлов паспортов ЗРИ, поиск теперь ведётся по кодам операции 11 и 85 
(раньше поиск вёлся только по коду 11).
3. При работе с паспортами, теперь допускается "-" в имени файла, "прим", "без ном" и т.д. автоматически заменяются на "-".
4. В аналитической выгрузке в Excel истории движения источника, добавлен отдельный лист, с записями по форме 1.5 (ранее была только форма 1.1).
5. Доработаны уведомления при обнаружении пересечения дат при импорте из файла .raodb или из Excel.

v.1.2.2.3 от 06.12.2022
1. Убран ползунок прокрутки из списка организаций, в списке отчетов ползунок прокрутки появляется при необходимости.
2. Исправлена ошибка отображения количества страниц при удалении из строки поиска последнего символа.
3. Убрано пересохранение текущей базы при выборе импорта из .raodb и последующей его отмене (вызывало задержку отклика программы).
4. Во всех выгрузках в Excel добавлены соответствующие сообщения. При успешной выгрузке добавлена возможность открыть файл выгрузки.
5. Исправлена ошибка, из-за которой в имя файла паспорта попадала полная дата, вместо года.
6. Исправлена ошибка в выгрузке в Excel форм 1.7, добавлено преобразование из экспоненциальной формы в числовую для необходимых полей.
7. Устранена ошибка, при которой при переключении страницы, использовании поиска или переходе из форм оперативной отчётности в годовые, 
не пропадал список форм для выбранной организации (теперь выбранная организация сбрасывается при изменении страницы/поиске).
8. Исправлена ошибка с "задвоением" организации при импорте отчётов в уже имеющуюся базу (требуется дальнейшее тестирование).
9. Устранена ошибка, при которой при изменении расположения файлов паспортов по умолчанию, поиск происходил в старой папке.